/*
**	Imager-LP DLL Header
**		version 1.9.1
*/
/*
Copyright(c)2017ЃgXgE\tgEFAEVXe, All Rights Reserved.
*/

#ifndef	IMAGER_LP_DLL_H
#define	IMAGER_LP_DLL_H

#ifdef IMAGERDLL_EXPORTS
#define MLPAPI __declspec(dllexport)
#else
#define MLPAPI __declspec(dllimport)
#endif
#ifdef	WINAPI
#undef	WINAPI
#endif
#define	WINAPI	__stdcall

#define	MLP_PICTURE_UNIT_PERCENT	1		/*摜̘_TCYw肷ۂ̒Pʂp[Zg*/
#define	MLP_PICTURE_UNIT_INCH		2		/*摜̘_TCYw肷ۂ̒PʂC`*/
#define	MLP_PICTURE_UNIT_MM			3		/*摜̘_TCYw肷ۂ̒Pʂ~[g[mm]*/

#include "MlpError.h"
#include "MlpDeclaration.h"

#ifdef	_UNICODE
#define	MlpInitialize		MlpInitializeW
#define	MlpLoadInitFile		MlpLoadInitFileW
#define	MlpLoadInitData		MlpLoadInitDataW
#define	MlpOpenDoc			MlpOpenDocW
#define	MlpOpenDocUsage		MlpOpenDocUsageW
#define	MlpValidateOwnerPassword	MlpValidateOwnerPasswordW
#define	MlpValidateUserPassword		MlpValidateUserPasswordW
#define	MlpPageToPict		MlpPageToPictW
#define	MlpCreatePict		MlpCreatePictW
#define	MlpConvertToTiff	MlpConvertToTiffW
#define	MlpRangeToTiff		MlpRangeToTiffW
#define	MlpCreateTiffRange	MlpCreateTiffRangeW
#define	MlpMultiPageToTiff	MlpMultiPageToTiffW
#define	MlpCreateTiffMulti	MlpCreateTiffMultiW
#define	MlpLicenseInfoStr	MlpLicenseInfoStrW
#define MlpPdfDocInfoEntry	MlpPdfDocInfoEntryW
#define MlpPanelToFile		MlpPanelToFileW
#define MlpSetDefaultFont	MlpSetDefaultFontW
#define MlpSetAlternateFont	MlpSetAlternateFontW
#define MlpSetAlternateFont2 MlpSetAlternateFont2W
#define MlpSetAlternateFontEx MlpSetAlternateFontExW
#else
#define	MlpInitialize		MlpInitializeA
#define	MlpLoadInitFile		MlpLoadInitFileA
#define	MlpLoadInitData		MlpLoadInitDataA
#define	MlpOpenDoc			MlpOpenDocA
#define	MlpOpenDocUsage		MlpOpenDocUsageA
#define	MlpValidateOwnerPassword	MlpValidateOwnerPasswordA
#define	MlpValidateUserPassword		MlpValidateUserPasswordA
#define	MlpPageToPict		MlpPageToPictA
#define	MlpCreatePict		MlpCreatePictA
#define	MlpConvertToTiff	MlpConvertToTiffA
#define	MlpRangeToTiff		MlpRangeToTiffA
#define	MlpCreateTiffRange	MlpCreateTiffRangeA
#define	MlpMultiPageToTiff	MlpMultiPageToTiffA
#define	MlpCreateTiffMulti	MlpCreateTiffMultiA
#define	MlpLicenseInfoStr	MlpLicenseInfoStrA
#define MlpPdfDocInfoEntry	MlpPdfDocInfoEntryA
#define MlpPanelToFile		MlpPanelToFileA
#define MlpSetDefaultFont	MlpSetDefaultFontA
#define MlpSetAlternateFont	MlpSetAlternateFontA
#define MlpSetAlternateFont2 MlpSetAlternateFont2A
#define MlpSetAlternateFontEx MlpSetAlternateFontExA
#endif

#ifdef	__cplusplus
extern "C" {
#endif

MLPAPI int WINAPI MlpInitializeW(wchar_t *license);
MLPAPI int WINAPI MlpInitializeA(char *license);
MLPAPI void WINAPI MlpUninitialize();

MLPAPI int WINAPI MlpLoadInitFileW(wchar_t *fileName);
MLPAPI int WINAPI MlpLoadInitFileA(char *fileName);
MLPAPI int WINAPI MlpLoadInitDataA(char *dta, int len);

MLPAPI int WINAPI MlpOpenDocW(const wchar_t *fileName,  const wchar_t *ownerPassword, const wchar_t *userPassword);
MLPAPI int WINAPI MlpOpenDocA(const char *fileName,  const char *ownerPassword, const char *userPassword);
MLPAPI int WINAPI MlpOpenMemDoc(unsigned char *data, size_t len,  const char *ownerPassword, const char *userPassword);
MLPAPI int WINAPI MlpOpenDocUsageW(const wchar_t *fileName,  const wchar_t *password, int usage);
MLPAPI int WINAPI MlpOpenDocUsageA(const char *fileName,  const char *password, int usage);
MLPAPI int WINAPI MlpOpenMemDocUsage(unsigned char *data, size_t len,  const char *password, int usage);
MLPAPI void WINAPI MlpCloseDoc();

MLPAPI int WINAPI MlpGetLibraryInfo(MlpLibraryOpt cmd, ...);
MLPAPI void WINAPI MlpShowLicenseInfo();
MLPAPI int WINAPI MlpLicenseInfoStrA(char *licenseStrPtr);

MLPAPI int WINAPI MlpGetDocumentInfo(int cmd, ...);
MLPAPI int WINAPI MlpPageCount();
MLPAPI int WINAPI MlpGetPageRotation(int pageNum, int *rotate);
MLPAPI int WINAPI MlpGetPageBoundary(int pageNum, int kind, float *userUnit, float *left, float *bottom, float *right, float *top);
MLPAPI int WINAPI MlpGetPageRawBoundary(int pageNum, int kind, float *userUnit, float *left, float *bottom, float *right, float *top);
MLPAPI int WINAPI MlpGetPicturePixel(int pageNum, int *x, int *y);
MLPAPI int WINAPI MlpGetPicturePixelX(int pageNum);
MLPAPI int WINAPI MlpGetPicturePixelY(int pageNum);
MLPAPI int WINAPI MlpGetCid0GlyphMode();
MLPAPI int WINAPI MlpPrintRestriction();

MLPAPI int WINAPI MlpSetPicturec(int opt, int val);
MLPAPI int WINAPI MlpSetPicture(MlpPictureOpt opt, ...);
MLPAPI int WINAPI MlpSetPictureSize(int x, int y, int unit);
MLPAPI int WINAPI MlpSetPictureRGB();
MLPAPI int WINAPI MlpSetPictureCMYK();
MLPAPI int WINAPI MlpSetPictureGray();
MLPAPI int WINAPI MlpSetPictureBW();
MLPAPI int WINAPI MlpSetPictureDither();
MLPAPI int WINAPI MlpSetPictureFaxG3();
MLPAPI int WINAPI MlpSetPictureFaxG4();
MLPAPI int WINAPI MlpSetPictureResolution(int dpi);
MLPAPI int WINAPI MlpSetPictureQuality(int quality);
MLPAPI int WINAPI MlpSetPicturePixelX(int x);
MLPAPI int WINAPI MlpSetPicturePixelY(int y);
MLPAPI int WINAPI MlpSetXYPicturePixel(int y);
MLPAPI int WINAPI MlpSetCanvasSize(int x, int y);
MLPAPI int WINAPI MlpSetTiffCompress(int mode);
MLPAPI int WINAPI MlpSetEnableAntialis();
MLPAPI int WINAPI MlpSetDisableAntialis();
MLPAPI int WINAPI MlpSetFillPathAAEnable();
MLPAPI int WINAPI MlpSetFillPathAADisable();
MLPAPI int WINAPI MlpSetCid0GlyphMode(int mode);
MLPAPI int WINAPI MlpSetPictureBufSize(int mb);

MLPAPI int WINAPI MlpValidateOwnerPasswordA(char *pass);
MLPAPI int WINAPI MlpValidateOwnerPasswordW(wchar_t *pass);
MLPAPI int WINAPI MlpValidateUserPasswordA(char *pass);
MLPAPI int WINAPI MlpValidateUserPasswordW(wchar_t *pass);

MLPAPI int WINAPI MlpSetCallbackFunc(int mode, int opt, void *function);

MLPAPI int WINAPI MlpSetCMYKProfile(char *fileName);
MLPAPI int WINAPI MlpSetRGBProfile(char *fileName);
MLPAPI int WINAPI MlpSetColorConvertForImage(int color_convert_direction, int flag);
MLPAPI int WINAPI MlpUnuseColorProfile();

MLPAPI int WINAPI MlpSetDefaultFontW(wchar_t *defaultFont);
MLPAPI int WINAPI MlpSetDefaultFontA(char *defaultFont);
MLPAPI int WINAPI MlpSetAlternateFontW(wchar_t *org, wchar_t *alt, int always);
MLPAPI int WINAPI MlpSetAlternateFontA(char *org, char *alt, int always);
MLPAPI int WINAPI MlpSetAlternateFontExA(char *org, char *alt, int always, int replace, int replace_on_render2, int alt_bold, int alt_italic, int weight, int style, int variant, Matrix *transform);

MLPAPI int WINAPI MlpPageToPictW(int pageNumber, int dpi, int quality, wchar_t *outputFilePath);
MLPAPI int WINAPI MlpPageToPictA(int pageNumber, int dpi, int quality, char *outputFilePath);
MLPAPI int WINAPI MlpCreatePictW(int pageNumber, wchar_t *outputFilePath);
MLPAPI int WINAPI MlpCreatePictA(int pageNumber, char *outputFilePath);
MLPAPI int WINAPI MlpRangeToTiffW(int startPageNum, int endPageNum, int dpi, wchar_t *outputFilePath);
MLPAPI int WINAPI MlpRangeToTiffA(int startPageNum, int endPageNum, int dpi, char *outputFilePath);
MLPAPI int WINAPI MlpCreatePictPageArrayW(int pageNumArray[], int length, wchar_t *outputFilePath);
MLPAPI int WINAPI MlpCreatePictPageArrayA(int pageNumArray[], int length, char *outputFilePath);		/*2017.6.16ǉ*/
MLPAPI int WINAPI MlpCreateTiffMultiW(const char *pageList, wchar_t *outputFilePath);
MLPAPI int WINAPI MlpCreateTiffMultiA(const char *pageList, char *outputFilePath);
MLPAPI int WINAPI MlpMultiPageToTiffW(const char *pageList, int dpi, wchar_t *outputFilePath);
MLPAPI int WINAPI MlpMultiPageToTiffA(const char *pageList, int dpi, char *outputFilePath);
MLPAPI int WINAPI MlpCreateTiffRangeW(int startPageNum, int endPageNum, wchar_t *outputFilePath);
MLPAPI int WINAPI MlpCreateTiffRangeA(int startPageNum, int endPageNum, char *outputFilePath);
MLPAPI int WINAPI MlpConvertToTiffW(wchar_t *outputFilePath);
MLPAPI int WINAPI MlpConvertToTiffA(char *outputFilePath);

MLPAPI int WINAPI MlpCreatePictBufPage(int pageNumber, unsigned char **pixels, int *width, int *height, int *nOfColors);
MLPAPI int WINAPI MlpCreatePictBufPageRange(int firstPageNumber, int lastPageNumber);
MLPAPI int WINAPI MlpCreatePictBufPageArray(int pages[], int len);
MLPAPI int WINAPI MlpCreatePictMem(int pageNumber);

MLPAPI int WINAPI MlpGetPictFromMem(unsigned char **pixels, int *width, int *height, int *nOfColors);
MLPAPI int WINAPI MlpGetPictFromMemIndex(int index, unsigned char **pixels, int *width, int *height, int *nOfColors, int *pageNumber);
MLPAPI int WINAPI MlpGetPictFromMemPage(int pageNumber, unsigned char **pixels, int *width, int *height, int *nOfColors);
MLPAPI int WINAPI MlpFreePictMem();

MLPAPI int WINAPI MlpGetOcgCount();
MLPAPI int WINAPI MlpGetOcgData(MlpOcgData *data[]);
MLPAPI int WINAPI MlpGetOcgUsage(MlpOcgUsage *usage[]);
MLPAPI int WINAPI MlpSetOcgState(MlpOcgData data[]);
MLPAPI int WINAPI MlpSetOcgStateU(MlpOcgUsage data[]);

MLPAPI int WINAPI MlpSetTextWidgetMultilineFontSize(float size);
MLPAPI float WINAPI MlpGetTextWidgetMultilineFontSize();
MLPAPI int WINAPI MlpSetTextWidgetMultilineUseLastSize(int use);
MLPAPI int WINAPI MlpGetTextWidgetMultilineUseLastSize();

MLPAPI int WINAPI MlpCreatePanel(int width, int height, int colorspace);
MLPAPI int WINAPI MlpClearPanel();
MLPAPI int WINAPI MlpFreePanel();
MLPAPI int WINAPI MlpPanelToFileA(char *filePath);
MLPAPI int WINAPI MlpMemPictToPanel(int x, int y, float alpha);
MLPAPI int WINAPI MlpMemPictToPanelBBox(int panel_xpos, int panel_ypos, float alpha, int bbox_xpos, int bbox_ypos, int bbox_width, int bbox_height);
MLPAPI int WINAPI MlpPaintRectToPanel(int xpos, int ypos, int width, int height, int lineWidth, unsigned char color[]);

MLPAPI int WINAPI MlpPrsGetFontInfo(PrsFontName **fontNameArray, int *len);
MLPAPI int WINAPI MlpPrsGetFontInfoWithTr(PrsFontName **fontNameArray, int *len);

MLPAPI int WINAPI MlpCreatePngFromPixels(unsigned char *pixels, int width, int height, int n_of_colors, char *fileName);
MLPAPI int WINAPI MlpCreatePngFromPixelsWAlpha(unsigned char *pixels, int width, int height, int n_of_colors, char *fileName);

#ifdef	__cplusplus
}
#endif

#endif	/*IMAGER_LP_DLL_H*/
